小工具知识网

当前位置: 首页 > 行业知识 > 力扣哈希表篇

行业知识

力扣哈希表篇

2026-11-01 06:31:14 来源:互联网转载

以下解题���路来自代码随想录以及力扣官方

()

文章目录

      • 242.有效的字母异位词
      • 349.两个数组的交集
      • 202.快乐数
      • 1.两数之和
      • 15.三数之和

        242.有效的字母异位词

        给定两个字符串 s 和 t ,编写一个函数来判断 t 是否是s 的字母异位词。

        ()
        输入: s = "anagram", t = "nagaram"输出: true输入: s = "rat", t = "car"输出: false
        class Solution {    public boolean isAnagram(String s, String t) {        int[] record = new int[26];        for (int i = 0; i  

        力扣官方题解使用排序方式也很简单

        class Solution {    public boolean isAnagram(String s, String t) {        if (s.length() != t.length()) {            return false;        }        char[] str1 = s.toCharArray();        char[] str2 = t.toCharArray();        Arrays.sort(str1);        Arrays.sort(str2);        return Arrays.equals(str1, str2);    }}

        349.两个数组的交集

        给定两个数组 nums1 和 nums2 ,返回它们的交集 .输出结果中的每个元素一定是唯一 的。我们可以不考虑输出结果的顺序 。

        输入:nums1 = [1,2,2,1], nums2 = [2,2]输出:[2]输入:nums1 = [4,9,5], nums2 = [9,4,9,8,4]输出:[9,4]解释:[4,9] 也是可通过的

        这道题思路还是比较容易理解的。

        class Solution {    public int[] intersection(int[] nums1, int[] nums2) {        if (nums1 == null || nums1.length == 0 || nums2 == null || nums2.length == 0) {            return new int[0];        }        // 这道题我们使用哈希来做        // 首先创建两个哈希表        HashSet set = new HashSet();        HashSet result = new HashSet();        // 将nums1中的元素全部添加进去        for (int i = 0; i  x).toArray();    }}

        202.快乐数

        编写一个算法来判断一个数 n 是不是快乐数。

        定义为:对于一个正整数,每一次将该数替换为它每个位置上的数字的平方和,然后重复这个过程直到这个数变为 1,也可能是无限循环但始终变不到 1。如果可以变为 1,那么这个数就是快乐数。如果 n 是快乐数就返回 True ;不是,则返回 False 。

        输入:n = 19输出:true解释:12 + 92 = 8282 + 22 = 6862 + 82 = 10012 + 02 + 02 = 1输入:n = 2输出:false
        class Solution {    public boolean isHappy(int n) {        Set set = new HashSet();        while (n != 1 && !set.contains(n)) {            set.add(n);            n = getNum(n);        }        return n == 1;    }    //获取数字平方和    public int getNum(int n){        int sum = 0;        while(n>0){            int temp = n%10;            sum+=temp * temp;            n = n/10;        }        return sum;    }}

        1.两数之和

        给定一个整数数组 nums 和一个目标值target,请你在该数组中找出和为目标值的那 两个整数,并返回他们的数组下标。

        你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

        输入:nums = [2,7,11,15], target = 9输出:[0,1]解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。输入:nums = [3,2,4], target = 6输出:[1,2]输入:nums = [3,3], target = 6输出:[0,1]

        我开始的解法,太垃圾了哈哈哈。

        class Solution {    public int[] twoSum(int[] nums, int target) {        int[] res = new int[2];        // 首先判断数组是否合规        if (nums == null || nums.length == 0) {            return new int[2];        }        HashMap map = new HashMap();        for (int i = 0; i  

        下面是力扣官方题解,

        class Solution {    public int[] twoSum(int[] nums, int target) {        Map hashtable = new HashMap();        for (int i = 0; i  

        15.三数之和

        输入:nums = [-1,0,1,2,-1,-4]输出:[[-1,-1,2],[-1,0,1]]解释:nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0 。nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0 。nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0 。不同的三元组是 [-1,0,1] 和 [-1,-1,2] 。注意,输出的顺序和三元组的顺序并不重要。输入:nums = [0,1,1]输出:[]解释:唯一可能的三元组和不为 0 。输入:nums = [0,0,0]输出:[[0,0,0]]解释:唯一可能的三元组和为 0 。

        有点难,下面题解是点赞第一的题解,还是很有思考性的。

        class Solution {    //定义三个指针,保证遍历数组中的每一个结果    //画图,解答    public List threeSum(int[] nums) {        //定义一个结果集        List res = new ArrayList();        //数组的长度        int len = nums.length;        //当前数组的长度为空,或者长度小于3时,直接退出        if(nums == null || len             return res;        }        //将数组进行排序        Arrays.sort(nums);        //遍历数组中的每一个元素        for(int i = 0; i            //如果遍历的起始元素大于0,就直接退出            //原因,此时数组为有序的数组,最小的数都大于0了,三数之和肯定大于0            if(nums[i]0){                break;            }            //去重,当起始的值等于前一个元素,那么得到的结果将会和前一次相同            if(i  0 && nums[i] == nums[i-1]) continue;            int l = i +1;            int r = len-1;            //当 l 不等于 r时就继续遍历            while(l                //将三数进行相加                int sum = nums[i] + nums[l] + nums[r];                //如果等于0,将结果对应的索引位置的值加入结果集中                if(sum==0){                    // 将三数的结果集加入到结果集中                    res.add(Arrays.asList(nums[i], nums[l], nums[r]));                    //在将左指针和右指针移动的时候,先对左右指针的值,进行判断                    //如果重复,直接跳过。                    //去重,因为 i 不变,当此时 l取的数的值与前一个数相同,所以不用在计算,直接跳                    while(l                                                 

上一篇:模拟器怎么代理服务器?

下一篇:【Java】面向对象的三大特征:封装、继承、多态